// ??? spr temp ujemne


#define	VER			"1.0"	// Wersja softu



/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1

#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC

#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define	BAUD	9600
#include <util/setbaud.h>							// Uart 0
#define	BAUD1	9600
#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>								// Tryby upienia
#include <avr/power.h>								// Wyaczanie peryferii


/*
// Interrupt Vectors Mega88 //
// Interrupt vector 0 is the reset vector. //

#define INT0_vect         _VECTOR(1)
#define INT1_vect         _VECTOR(2)
#define PCINT0_vect       _VECTOR(3)
#define PCINT1_vect       _VECTOR(4)
#define PCINT2_vect       _VECTOR(5)
#define PCINT3_vect       _VECTOR(6)
#define WDT_vect          _VECTOR(7)
#define TIMER1_CAPT_vect  _VECTOR(8)
#define TIMER1_COMPA_vect _VECTOR(9)
#define TIMER1_COMPB_vect _VECTOR(10)
#define TIMER1_OVF_vect   _VECTOR(11)
#define TIMER0_COMPA_vect _VECTOR(12)
#define TIMER0_COMPB_vect _VECTOR(13)
#define TIMER0_OVF_vect   _VECTOR(14)
#define SPI_STC_vect      _VECTOR(15)
#define ADC_vect          _VECTOR(16)
#define EE_READY_vect     _VECTOR(17)
#define ANALOG_COMP_vect  _VECTOR(18)
#define TWI_vect          _VECTOR(19)

#define _VECTORS_SIZE 40


// Constants //
#define RAMEND       0x1FF
#define XRAMSIZE     0
#define XRAMEND      RAMEND
#define E2END        0x3F
#define E2PAGESIZE   4
#define FLASHEND     0x1FFF
#define SPM_PAGESIZE 32
*/    



/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	portKEY			PORTB								// Port do ktorego podlaczono klawisze
#define	KEYd4			PB0				// UP
#define	KEYd5			PB1				// DOWN
#define	KEYd6			PB2				// ENTER
#define	KEYd7			PB4				// ESC
#define	SelPinUP()		portKEY &= ~(1<<KEYd4); _delay_us(100);	// Wybranie pinu do odczytu przez "RdKey" - nie zmieniamy kierunku, bo sa to linie wyjsciowe LCD 
#define	SelPinDOWN()	portKEY &= ~(1<<KEYd5); _delay_us(100);	// j.w.
#define	SelPinENTER()	portKEY &= ~(1<<KEYd6); _delay_us(100);	// j.w.
#define	SelPinESC()		portKEY &= ~(1<<KEYd7); _delay_us(100);	// j.w.
#define	DeSelKey()		portKEY |= ( (1<<KEYd4) | (1<<KEYd5) | (1<<KEYd6) | (1<<KEYd7) )
#define	INKEY			PD2									// Pin wejciowy dla UP, DW, ENTER i ESC
#define	pinINKEY		PIND								// Port z ktorego odczytujemy klawisze
#define	portINKEY		PORTD								// Port podciagajacy w/w pin
#define	ddrINKEY		DDRD								// Rejestr kierunku w/w portu
#define	KeyDdr()		ddrINKEY &= ~(1<<INKEY); portINKEY |= (1<<INKEY)	// Ustawienie kierunku i podciagnicie pinu odczytu klawiszy
#define	RdKey			(pinINKEY & (1<<INKEY) )			// Odczyt pinu wejsciowego




#include "include/lcd.h";
#include "include/lcd.c";
void UstawTypLcd();
extern unsigned char LCDLINE;		// Liczba wierszy (jako zmienna)
extern unsigned char LCDROW;


/*
extern void LcdInit();
extern void LcdDataOut();
extern void LcdPutCGRAM(byte NrZnaku);
extern void LcdSendCommand(unsigned char command);
extern void LcdSendNible(unsigned char command);
extern void LcdSendByte(unsigned char command);
extern void LcdSendData(unsigned char data);
extern void LcdSetCursorPosition(unsigned char row,unsigned char line);
extern void LcdPrint(char* text);
extern void LcdPrint_P(char* text);
extern void LcdPrintChar(char character);
extern char LcdWin2Lcd(char znak);
extern void LcdNextLine();
extern void LcdClr();
#define	LcdCls	LcdClr
#define	LcdDispayOn()	LcdSendCommand(0xC)
#define	LcdDisplayOff()	LcdSendCommand(0x8)
#define	LcdCursorOn()  	LcdSendCommand(0xF)	// 0xE bez migania
#define	LcdCursorOff() 	LcdSendCommand(0xC)
#define	LcdHome()  		LcdSendCommand(0x2); lcdv=0; lcdh=0
*/
void Demo();
void _delay_s( byte sek, byte ms );


void PrintOff();
void PrintU( int wynik, float k );
void PrintUI( int wynik, int spadek, float k );
void PrintI( int wynik, float k );
void PrintP( int napiecie, float ku, int prad, float ki );
void PrintT( int wynik, float k );
void PrintPomiary();
void PrintWgCfg( byte we, byte row, byte line );


void InitTimer0();
void InitWdg();


#define	ADCWEJSC	8
word pomiar(byte kanal);
void Pomiary();
#define	WE0	4
#define	WE1	5
#define	WE2	6
#define	WE3	7

#define	WE4	3
#define	WE5	2
#define	WE6	1
#define	WE7	0
int Srednia[ADCWEJSC];
int pSrednia[ADCWEJSC];
char buflcd[64];
byte WeLog2weFiz( byte we);


uint32_t sygnatura_eeprom	= 0x55485054;		// "UIPT"
uint32_t EEsygnatura EEMEM	= 0x55485054;		// "UIPT";
byte wersja_eeprom			= 0x10;				// Wersja pliku konfiguracyjnego
byte EEwersja EEMEM			= 0x10;				// Wersja pliku konfiguracyjnego
enum { LCD2x16, LCD2x20, LCD4x16, LCD4x20, LCD_xEND };
byte TypLcd					= LCD2x16;
byte EEtyplcd EEMEM			= LCD2x16;
enum { CFG_O, CFG_U,
 #if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
 CFG_UI,
 #endif
 CFG_I,
 #if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
 CFG_P,
 #endif
 CFG_T, CFG_END };
enum { CFGP_12, CFGP_23, CFGP_34, CFGP_45, CFGP_56, CFGP_67, CFGP_78, CFGP_END };   
#define	KAL_U	5.14
#define	KAL_I	1.0
#define	KAL_T	4.30
#define	KAL_P	1.0
//	Numeracja wejsc na LCD:
//	+----------------+
//	| WE1		WE0	 |
//	| WE3		WE2	 |
//	| WE5		WE4	 |
//	| WE7		WE6	 |
//	+----------------+
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
 byte Cfg[ADCWEJSC]			= { CFG_I, CFG_U, CFG_P, CFG_T, CFG_T, CFG_U, CFG_T, CFG_I };
 byte EEcfg[ADCWEJSC] EEMEM	= { CFG_I, CFG_U, CFG_P, CFG_T, CFG_T, CFG_U, CFG_T, CFG_I };
 float Kal[ADCWEJSC]		= { KAL_I, KAL_U, KAL_P, KAL_T, KAL_T, KAL_U, KAL_T, KAL_I };
 float EEkal[ADCWEJSC] EEMEM= { KAL_I, KAL_U, KAL_P, KAL_T, KAL_T, KAL_U, KAL_T, KAL_I };
 byte CfgP[ADCWEJSC]		= { CFGP_12, CFGP_23, CFGP_12, CFGP_45, CFGP_56, CFGP_67, CFGP_78, CFGP_78 };
 byte EEcfgP[ADCWEJSC] EEMEM= { CFGP_12, CFGP_23, CFGP_12, CFGP_45, CFGP_56, CFGP_67, CFGP_78, CFGP_78 };
#else
 byte Cfg[ADCWEJSC]			= { CFG_I, CFG_U, CFG_U, CFG_T, CFG_T, CFG_U, CFG_T, CFG_I };
 byte EEcfg[ADCWEJSC] EEMEM	= { CFG_I, CFG_U, CFG_U, CFG_T, CFG_T, CFG_U, CFG_T, CFG_I };
 float Kal[ADCWEJSC]		= { KAL_I, KAL_U, KAL_U, KAL_T, KAL_T, KAL_U, KAL_T, KAL_I };
 float EEkal[ADCWEJSC] EEMEM= { KAL_I, KAL_U, KAL_U, KAL_T, KAL_T, KAL_U, KAL_T, KAL_I };
#endif


void ReadCfg();
void WriteCfg();


byte ReadKey();
byte RdK();
void WaitFreeKey();
byte WaitKey();
#define	KEY_NONE	0
#define	KEY_UP		1
#define	KEY_DOWN	2
#define	KEY_ENTER	4
#define	KEY_ESC		8


void KalibracjaMiernika();
void KalibracjaKanalu(byte we);


word TestStosu();


/************************************************************************/
/*				Prawa autorskie											*/
/************************************************************************/
//	 				  1234567890123456
 char CODE nazwa[] = "Miernik UIPT \0"; 
 char CODE versja[]= VER;
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
 char CODE dzien[] = __DATE__;					// Data kompilacji
#endif
//char CODE czas[] = __TIME__;					// Czas kompilacji
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
 char CODE firma[] = "(C) 2012 AVT\0";
 #ifdef	CHAR_PL
  char CODE autor[] = "S.Skrzyski\0";
 #else
  char CODE autor[] = "S.Skrzynski\0";
 #endif
#endif



//------------------------------------------------------------------//
//				Sekcja ".initX"	(ZERO zainicjalizowane)				//
//------------------------------------------------------------------//
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
unsigned char DnoStosu NOINIT;			// Kontrola stosu
void ClrIntRam(void) __attribute__ ((naked)) __attribute__ ((section (".init3")));
void ClrIntRam(void)
{
unsigned char *AdrRam;
	//--- Zapisujemy od ostatniej zajetej komrki ram do wierzchoka stosu -32 bajty rezerwy ---
	for (AdrRam=&DnoStosu; AdrRam < (unsigned char*)RAMEND-32; AdrRam++)			// Wpisanie do IntRam $FF
		{
		*AdrRam = 0xFF;
		}
}
#endif
//----------------------------------------------------------------------//
//				Sprawdz zajeto stosu									//
// Zuywa do duo czasu procesora
//----------------------------------------------------------------------//
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
word TestStosu()
{
unsigned char *AdrRam;
unsigned int cnt=0;


	//--- Sprawdzamy od ostatniej zajetej komrki ram do wierzchoka stosu -32 bajty rezerwy ---
	for (AdrRam=(&DnoStosu)+1; AdrRam < (unsigned char*)RAMEND-32; AdrRam++)			// Wpisanie do IntRam $FF
		{
		cnt++;
		if (*AdrRam != 0xFF)
			{
/*
			if (cnt < 32 )
				{							// Jesli za may obszar to generuj bd
				PrintString_P(PSTR(CRLF"!ERR RAM. Zostalo "));
				sprintf_P(buforU,PSTR("$%04x"),cnt);
				PrintString(buforU);
				}
*/
			return( cnt );
			}
		}
return( cnt );
}
#endif
/*
//----- Przykad testowania zajetosci stosu -----//
	if ( (TestStosu() < 32 )
		{							// Jesli za may obszar to generuj bd
		PrintString_P(PSTR(CRLF"!ERR RAM. Zostalo "));
		sprintf_P(buforU,PSTR("$%04x"),FreeRam);
		PrintString(buforU);
		}
*/




/*
#ifdef CPULOCK
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
#else
	#warning "Nie ustawione LockBits"
#endif
*/




#if defined(__AVR_ATmega88__) || defined(__AVR_ATmega88P__) || defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)
__fuse_t __fuse __attribute__((section (".fuse"))) = 
{
	.extended = 0xF9,
	.high = 0xCC,
	.low = 0x62,
};
#else
	#error "Nie ustawione FuseBits"
#endif




/********************************************************************************/
/*																				*/
/********************************************************************************/
int main()
{



//	InitTimer0();					// ustawia timer na IRQ

	InitWdg();

	sei();


	LcdInit();
	KeyDdr();						// kierunek linii odczytujacej klawisze


	ReadCfg();						// Konfig z EEprom






	if ( ReadKey() == KEY_DOWN )
		{
		KalibracjaMiernika();		// Wejscie w konfiguracje
		}
	else
		{
		Demo();
		}




	LcdCls(); LcdHome();
	//---------------------------------------//
	//-				Ptla gwna			-//
	//---------------------------------------//
	while(1)
		{
		wdt_reset();


		Pomiary();					// dokonaj pomarw wejsc		
		PrintPomiary();				// wyswietlanie wynikow


		#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
		 word FreeRam=0;
		 if ( ((FreeRam=TestStosu()) < 32) || (ReadKey() == KEY_ENTER) )
			{							// Jesli za may obszar to generuj bd
			LcdCls(); LcdHome();
			LcdPrint_P(PSTR("!ERR RAM Zostalo "));
			sprintf_P( buflcd, PSTR("%d/%d/%d"), FreeRam, &DnoStosu, RAMEND); LcdPrint( buflcd );
			WaitFreeKey();
			}
		#endif

		_delay_ms(100);				// Liczba pomiarow na sekunde (200 to 5 pomiarow)
		}
}



//----------------------------------------------------------------------//
//					Menu kalibracja										//
//----------------------------------------------------------------------//
void KalibracjaMiernika()
{
byte we, key;


	
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
	while( 1 )							//----- Konfiguracja LCD -----//
		{
		wdt_reset();
		LcdCls(); LcdHome();
		LcdPrint_P( PSTR( "Konfiguracja" ) );
		LcdNextLine();
		switch( TypLcd )
			{
			case( LCD2x16 ): LcdPrint_P( PSTR( "LCD2x16" ) ); break;
			case( LCD2x20 ): LcdPrint_P( PSTR( "LCD2x20" ) ); break;
			case( LCD4x16 ): LcdPrint_P( PSTR( "LCD4x16" ) ); break;
			case( LCD4x20 ): LcdPrint_P( PSTR( "LCD4x20" ) ); break;
			}
		WaitFreeKey();											// Czekaj na zwolnienie klawisza
		key = WaitKey();										// Czekaj na klawisz
		if ( (key == KEY_UP) || (key == KEY_DOWN) )				// Jesli UP lub DOWN
			{
			TypLcd++; if (TypLcd >= LCD_xEND) TypLcd = 0;
			}
		if ( key == KEY_ENTER )									// Wcisnieto ENTER
			{
			WriteCfg();					// Zapis do eeprom
			break;
			}
		if ( key == KEY_ESC )
			{
			ReadCfg();					// Odczyt z eeprom
			break;
			}
		}
	WaitFreeKey();
#endif


	for (we=0; we<ADCWEJSC; we++)									//----- Konfiguracja wejsc -----//
		{
		while( 1 )
			{
			wdt_reset();
			LcdCls(); LcdHome();
			LcdPrint_P( PSTR( "Konfiguracja" ) );
			LcdNextLine();
			sprintf(buflcd, "We%d - ", we+1 ); LcdPrint( buflcd );	
			switch( Cfg[we] )
				{
				case( CFG_O ): LcdPrint_P( PSTR( "Off" ) ); break;
				case( CFG_U ): LcdPrint_P( PSTR( "U" ) ); break;
				#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
				 case( CFG_UI): LcdPrint_P( PSTR( "Ui" ) ); break;
				 case( CFG_P ): LcdPrint_P( PSTR( "P" ) ); break;
				#endif
				case( CFG_I ): LcdPrint_P( PSTR( "I" ) ); break;
				case( CFG_T ): LcdPrint_P( PSTR( "T" ) ); break;
				}
			WaitFreeKey();											// Czekaj na zwolnienie klawisza
			key = WaitKey();										// Czekaj na klawisz
			if ( (key == KEY_UP) || (key == KEY_DOWN) )				// Jesli UP lub DOWN
				{
				Cfg[we]++;											// Zmien typ wejscia
				#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
				 if ( (Cfg[we] == CFG_UI) && (Cfg[we-1] != CFG_I) ) { Cfg[we]++; }	// Tryb "Ui" tylko gdy poprzednie wejscie w trybie "I"
				#endif
				if ( Cfg[we] >= CFG_END) { Cfg[we] = 0; }			// Gdy ostatni typ to ustaw pierwszy
				}
			if ( key == KEY_ENTER )									// Wcisnieto ENTER
				{
				switch( Cfg[we] )									// wiec zapis korekte domyslna
					{
					case( CFG_U ): Kal[we] = KAL_U; break;
					#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
					 case( CFG_UI): Kal[we] = KAL_U; break;
					 case( CFG_P ): Kal[we] = KAL_P; break;
					#endif
					case( CFG_I ): Kal[we] = KAL_I; break;
					case( CFG_T ): Kal[we] = KAL_T; break;
					}
				WriteCfg();					// Zapis do eeprom
				WaitFreeKey();
				KalibracjaKanalu( we );
				break;
				}
			if ( key == KEY_ESC )
				{
				ReadCfg();					// Odczyt z eeprom
				break;
				}
			}
		WaitFreeKey();
		}
}


//----------------------------------------------------------------------//
void KalibracjaKanalu(byte we)
{
byte key;
int wynik;
byte repeat=0;
float precyzjaL=0, precyzjaH=0, KalStd=0;


#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
	if ( Cfg[we] == CFG_P )					// jesli konfigurujemy wejscie pomiaru mocy
		{
		while( 1 )
			{
			wdt_reset();
			Pomiary();							// dokonaj pomarw wejsc		
			LcdCls(); LcdHome();
			sprintf(buflcd, "P = We%d * We%d", CfgP[we]+1, CfgP[we]+2 ); LcdPrint( buflcd );	

			PrintWgCfg( we, 0, 1 );						// Wyswietl na okreslonej pozycji

			WaitFreeKey();											// Czekaj na zwolnienie klawisza
			key = WaitKey();										// Czekaj na klawisz
			if ( (key=ReadKey()) == KEY_NONE )
				{
				wdt_reset();
				}
			else if ( (key==KEY_UP) || (key==KEY_DOWN) )
				{
				CfgP[we]++; if ( CfgP[we] >= CFGP_END ) { CfgP[we] = 0; }
				}
			else if ( key == KEY_ESC )						// Wyjscie bez zmian
				{
				ReadCfg();								// Odczyt z eeprom
				return;
				}				
			else if ( key == KEY_ENTER )
				{
				WriteCfg();								// Zapis do eeprom
				return;
				}
			}
		}
#endif


	wdt_reset();
	switch( Cfg[we] )
		{
		case( CFG_T ): precyzjaH = 0.001; precyzjaL = 0.01; KalStd = KAL_T; break;	// precyzja dla "T"
		case( CFG_U ): precyzjaH = 0.01;  precyzjaL = 0.1;  KalStd = KAL_U; break;	// precyzja dla "U"
		#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
		 case( CFG_UI): precyzjaH = 0.01;  precyzjaL = 0.1;  KalStd = KAL_U; break;	// precyzja dla "U"
		#endif
		case( CFG_I ): precyzjaH = 0.01;  precyzjaL = 0.1;  KalStd = KAL_I; break;	// precyzja dla "I"
		}



	LcdCls(); LcdHome();
	sprintf(buflcd, "Kalibracja We%d", we+1 ); LcdPrint( buflcd );	


	while( 1 )
		{
		wdt_reset();
		Pomiary();							// dokonaj pomarw wejsc		
		PrintWgCfg( we, 0, 1 );
	

		LcdSetCursorPosition(LCDROW>>1 ,1);	// Ustaw pozycje
		wynik = ( Kal[we] - KalStd )  * 100;
		if ( wynik < 0 ) { key = '-'; } else { key = '+'; }		// Wyswietlenie znaku (konieczne z powodu sposobu wyswietlania przez MOD wartosci ujemnych		
		sprintf(buflcd, "k%c%d.%02d ", key, abs(wynik/100), abs(wynik % 100) ); LcdPrint( buflcd );


		_delay_ms(100);
		if ( (key=ReadKey()) == KEY_NONE )
			{
			wdt_reset(); repeat = 0;
			}
		else
			{
			if ( repeat < 100) repeat++; 
			if ( key == KEY_ESC )						// Wyjscie bez zmian
				{
				ReadCfg();								// Odczyt z eeprom
				return;
				}				
			else if ( key==KEY_UP )
				{
				if ( repeat > 10 )						// Repetycji wiecje niz 10
					{	
					Kal[we] += precyzjaL;				// Zwiekszaj o 0,1
					}	
				else									// Repetycji mniej niz 10
					{
					Kal[we] += precyzjaH;				// Zwiekszaj o 0,01
					}
				}
			else if ( key==KEY_DOWN )
				{
				if ( repeat > 10 )
					{
					Kal[we] -= precyzjaL;
					}
				else
					{
					Kal[we] -= precyzjaH;
					}
				}
			else if ( key == KEY_ENTER )
				{
				WriteCfg();								// Zapis do eeprom
				return;
				}
			}
		}
	WaitFreeKey();
}


//----------------------------------------------------------------------//
//					Odczyt klawiaruty									//
//----------------------------------------------------------------------//
byte ReadKey()
{
byte key = 0xFE;


	while( key != RdK() )
		{
		_delay_ms(50);
		key = RdK();
		} 

return( key );
}


//----------------------------------------------------------------------//
byte RdK()
{
byte key=KEY_NONE;


	DeSelKey();	SelPinUP();		if ( !RdKey ) { key |= KEY_UP; }
	DeSelKey(); SelPinDOWN(); 	if ( !RdKey ) { key |= KEY_DOWN; }
	DeSelKey(); SelPinENTER(); 	if ( !RdKey ) { key |= KEY_ENTER; }
	DeSelKey(); SelPinESC(); 	if ( !RdKey ) { key |= KEY_ESC; }

return( key );
}


//----------------------------------------------------------------------//
void WaitFreeKey()							// Czekaj na zwolnienie klawisza
{
	while( ReadKey() != KEY_NONE ) { wdt_reset(); }
}


//----------------------------------------------------------------------//
byte WaitKey()								// Czekaj na nacisniecie klawisza
{
byte key;

	while( (key=ReadKey()) == KEY_NONE ) { wdt_reset(); }

return ( key );
}


//----------------------------------------------------------------------//
//					Wyswietla wszystkie wyniki							//
//----------------------------------------------------------------------//
void PrintPomiary()
{
byte static Pkey=0, scr=0;
byte key;


	key = ReadKey();						// Odczyt klawisza
	if ( key != Pkey ) { LcdInit(); /* LcdCls(); */ }			// Jesli nacisnieto jakikolwiek klawisz wyczysc ekran
	Pkey = key;
		
	switch ( key )							// Wybor wyswietlanego ekranu
		{
		case( KEY_UP ): scr = 0; break;
		case( KEY_DOWN ): scr = 1; break;
		}

	if ( (LCDLINE == 4) || 					// Dla 4 liniowego zawsze wyswietlamy pierwszy ekran
		 ((LCDLINE == 2) && (scr == 0)) )	// Dla 2 liniowego LCD sa dwa ekrany, gdy UP nienacisniety wyswietlamy pierwszy
		{
		PrintWgCfg( 0, LCDROW>>1, 0 );		// Ustaw 1 linie
		PrintWgCfg( 1, 0, 0 );
	
		PrintWgCfg( 2, LCDROW>>1, 1 );		// Ustaw 2 linie
		PrintWgCfg( 3, 0 ,1 );
		}

	if ( (LCDLINE == 2) && (scr == 1) )		// Dla 2 liniowego LCD sa dwa ekrany, Jeli nacinity UP wyswietlamy ekran drugi
		{
		PrintWgCfg( 4, LCDROW>>1, 0 );		// Ustaw 1 linie
		PrintWgCfg( 5, 0, 0 );

		PrintWgCfg( 6, LCDROW>>1, 1 );		// ustaw 2 linie
		PrintWgCfg( 7, 0, 1 );
		}

	#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)		// Funkcje dostepne dla M168
	 if (LCDLINE == 4)
		{
		PrintWgCfg( 4, LCDROW>>1, 2 );		// ustaw 3 linie
		PrintWgCfg( 5, 0 ,2 );

		PrintWgCfg( 6, LCDROW>>1, 3 );		// ustaw 4 linie
		PrintWgCfg( 7, 0 ,3 );
		}
	#endif
}


//----------------------------------------------------------------------//
void PrintWgCfg( byte we, byte row, byte line )
{
byte wejFiz=0;
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)		// Funkcje dostepne dla M168
 byte weU=0, weI=0;
#endif

	LcdSetCursorPosition(row ,line);			// Ustaw pozycje

	wejFiz = WeLog2weFiz( we );

	switch( Cfg[we] )
		{
		case( CFG_O ): PrintOff(); break;
		case( CFG_U ): PrintU( Srednia[wejFiz], Kal[we] ); break;
		case( CFG_I ): PrintI( Srednia[wejFiz], Kal[we] ); break;
		#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
		 case( CFG_UI): PrintUI( Srednia[wejFiz], Srednia[WeLog2weFiz(we-1)], Kal[we] ); break;
		 case( CFG_P ):
		 weU = CfgP[we];
		 weI = weU + 1;
		 PrintP( Srednia[WeLog2weFiz(weU)], Kal[weU], Srednia[WeLog2weFiz(weI)], Kal[weI] ); break;
		#endif
		case( CFG_T ): PrintT( Srednia[wejFiz], Kal[we] ); break;
		}
}


//----------------------------------------------------------------------//
//					Wyswietla wynik pomiaru								//
//----------------------------------------------------------------------//
void PrintOff()
{
			// 12345678
	LcdPrint_P( PSTR( "        ") );
}



//----------------------------------------------------------------------//
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
void PrintUI( int wynik, int spadek, float kal )
{
	spadek = spadek / 10;

	wynik = wynik * kal;			// Korekta wyniku (wplyw dzielnika wejciowego)
	wynik = wynik + spadek;
//	wynik = 100 to 1V

	if (wynik < 0) wynik=0;			// Napiecie nie moze byc nizsze niz 0V
	sprintf(buflcd, "U=%2d.%dV", wynik/100, (wynik % 100)/10  ); LcdPrint( buflcd );
//	sprintf(buflcd, "%dmV", wynik ); LcdPrint( buflcd );
}
#endif


//----------------------------------------------------------------------//
void PrintU( int wynik, float kal )
{
	wynik = wynik * kal;			// Korekta wyniku (wplyw dzielnika wejciowego)
//	wynik = 100 to 1V

	if (wynik < 0) wynik=0;			// Napiecie nie moze byc nizsze niz 0V
	sprintf(buflcd, "U=%2d.%dV", wynik/100, (wynik % 100)/10  ); LcdPrint( buflcd );
//	sprintf(buflcd, "%dmV", wynik ); LcdPrint( buflcd );
}


//----------------------------------------------------------------------//
void PrintI( int wynik, float kal )
{
	wynik = wynik * kal;			// Korekta wyniku
//	wynik = 100 to 100mV czyli 1A

	if (wynik < 0) wynik=0;			// Prad nie moze byc nizszy niz 0V
	sprintf(buflcd, "I=%2d.%dA", (int)wynik/100, (int)(wynik % 100)/10 ); LcdPrint( buflcd );
//	sprintf(buflcd, "%d0mA", wynik ); LcdPrint( buflcd );
}


//----------------------------------------------------------------------//
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
void PrintP( int napiecie, float kalU, int prad, float kalI )
{
int wynik, wynikU, wynikI;


	wynikU = napiecie * kalU / 10;	// Korekta napiecia
	wynikI = prad * kalI / 10;			// Korekta pradu
	wynik = wynikU * wynikI;


	if (wynik < 0) wynik=0;			// Moc nie moze byc nizsza niz 0V
	sprintf(buflcd, "P=%2d.%dW", (int)(wynik/100), (int)(wynik % 100)/10 ); LcdPrint( buflcd );
	if ( (wynik < 1000) && (wynik >= 0) )	// Kasujemy ewentualna litere "W" wynikajaca z wyswietlania 
		{									// jednostki przy mocy wiekszej od 99 W
	 	LcdPrint_P( PSTR( " ") );	
		}
//	sprintf(buflcd, "%dmW", (int)wynik ); LcdPrint( buflcd );
}
#endif


//----------------------------------------------------------------------//
void PrintT( int wynik, float kal )
{


//----- testowe -----//
/*
	wynik *= 4;
	wynik -= 2730;
	sprintf(buflcd, "%dmV", wynik ); LcdPrint( buflcd );
	return;
*/
//----- end -----//



	wynik = wynik * kal;			// Korekta wyniku (wplyw dzielnika wejciowego 3k i 1k)
//	2730mV =   0 stopni Celcjusza
//	2982mV =  25 stopni Celcjusza
//	4730mV = 200 stopni Celcjusza
//wynik = 2982;	//???? to odpowiada 25 stopnim Celcjusza
//
//	temp = Uwe - 2730mV;
//  temp = 2992mV - 2730;
//  temp = 26.2 stopnia 


	wynik -= 2730;				// Odejmujemy "Kelwiny" (237 Celciusze, czyli 2,73V)


	#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)		// Funkcje dostepne dla M168
	 if (wynik < -990 ) wynik = -990;		// Min temp -99 stopni
	 if (wynik > 2000 ) wynik = 9999;		// Max temp 200 stopni
	#endif

	sprintf(buflcd, "T=%d.%1dC", (int)wynik/10, (int)abs(wynik % 10) ); LcdPrint( buflcd );

	 if ( (wynik < 1000) && (wynik >= 0) )	// Kasujemy ewentualna litere "C" wynikajaca z wyswietlania 
		{									// jednostki przy temp. ujemnych lub wiekszych od 99 stopni
	 	LcdPrint_P( PSTR( " ") );	
		}
}



//----------------------------------------------------------------------//
//					Konwertuje nr wejscia logicznego na fizyczne
//----------------------------------------------------------------------//
byte WeLog2weFiz( byte we)
{
byte wejFiz=0;



	switch( we )
		{
		case( 0 ): wejFiz = WE0; break;
		case( 1 ): wejFiz = WE1; break;
		case( 2 ): wejFiz = WE2; break;
		case( 3 ): wejFiz = WE3; break;
		case( 4 ): wejFiz = WE4; break;
		case( 5 ): wejFiz = WE5; break;
		case( 6 ): wejFiz = WE6; break;
		case( 7 ): wejFiz = WE7; break;
		}
return( wejFiz );
}


//----------------------------------------------------------------------//
//					Pomiar wszystkich wej								//
//----------------------------------------------------------------------//
void Pomiary()
{
#define	ADCPOMIAROW	64				// Liczba pomiarow do obliczenia sredniej
#define	ADCODCHYLKA	3				// Minimalna odchylka ktora pokazujemy na wyswietlaczu (likwiduje "miganie" ostatniej cyfry)
//#define	AUTOZERO

uchar x=0, y=0;
int w;
#ifdef AUTOZERO
 int AutoZero = 0;
#endif



		#ifdef AUTOZERO
		  AutoZero = pomiar( 0xF );						// Autozerowanie
		#endif
		for (x=0; x<ADCWEJSC; x++)
			{
			Srednia[x] = 0;								// Zerowanie sredniej
			for (y=0; y<ADCPOMIAROW; y++)
				{
				w = pomiar( x );						// Pomiar
				#ifdef AUTOZERO
				  w -= AutoZero;
				#endif
//				  if (w <= 1000)						// Do wyliczenia sredniej bierzemy tylko liczby nie wieksze niz 1000 (nieprzekroczony zakres ADC)
					{
					Srednia[x]	= ( Srednia[x] + w ) >> 1;	
					// Wynikow nie zbieramy w tablicy, a pozniej wyliczamy srednia, tylko
					// na bierzaco dodajemy i dzielimy na 2, dzieki czemu bez zuzywania RAM na tablice mozemy zwiekszac liczbe pomiarow
					// Ponadto do wyliczenia sredniej przy kolejnym obiegu petli brany jest pod uwage poprzedni wynik
					}
				}
			if ( Srednia[x] < 0 ) Srednia[x] = 0;		// Wynik mniejszy niz 0 niemozliwy ale moze wynikac z "AutoZero"
			if ( abs( Srednia[x] - pSrednia[x]) >= ADCODCHYLKA )	// Jesli wynik pomiaru rozny o wiecej niz ADCODCHYLKA od poprzedniego
				{
				pSrednia[x] = Srednia[x];				// zapamietaj wynik do kolejnych porownan
				}										// w Srednia[] mamy nowy wynik
			else										// Jesli roznica mniejsza
				{
				Srednia[x] = pSrednia[x];				// daj poprzedni pomiar
				}										// w Srednia[] mamy stary wynik
			}
}



//----------------------------------------------------------------------//
//					Pomiar sygnau										//
//----------------------------------------------------------------------//
word pomiar(byte kanal)
{
#define	ADIRQ					// deklaracja wlacza obsluge ADC na IRQ (wylaczanie CPU na czas pomiaru - mniejsze szumy)


	ADMUX = (3<<REFS0) + kanal;									// Aref=1,1V, ADLAR=0: s.254 noty katalogowej
	ADCSRA = (1<<ADIF);
	#ifdef ADIRQ
	 ADCSRA = (1<<ADEN) + (1<<ADSC) + (3<<ADPS0) + (1<<ADIE);	// zegar: s.246 noty (1MHz / 16 = 62,5kHz)
	 set_sleep_mode( SLEEP_MODE_ADC );							// Upij procka (minimalizacja szumow), IRQ ADC go wybudzi
	 sleep_mode();
	#else
	 ADCSRA = (1<<ADEN) + (1<<ADSC) + (3<<ADPS0);				// zegar: s.246 noty (1MHz / 16 = 62,5kHz)
	 while ( (ADCSRA & (1<<ADIF) ) == 0 ) nop();				// Czekaj na koniec kowersji
	#endif

	return( ADC );
}


//----------------------------------------------------------------------//
INTERRUPT( ADC_vect )			// Przerwanie sluzy tylko do wybudzenia CPU z uspienia
{
	nop();
}


//----------------------------------------------------------------------//
//					Demo 												//
//----------------------------------------------------------------------//
void Demo()
{
	LcdCls(); LcdHome();
	LcdPrint_P( nazwa ); LcdPrint_P( versja );	
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)		// Funkcje dostepne dla M168
	 LcdSetCursorPosition(0 ,1);		// Ustaw 2 linie
	 LcdPrint_P( dzien );
	 if ( LCDLINE == 4 )
		{
		LcdSetCursorPosition(0 ,2);		// Ustaw 3 linie
		LcdPrint_P( firma );	
		LcdSetCursorPosition(0 ,3);		// Ustaw 4 linie
		LcdPrint_P( autor );
		}
	 else
		{
		_delay_s( 2,0 );
		LcdCls(); LcdHome();
		LcdPrint_P( firma );	
		LcdSetCursorPosition(0 ,1);		// Ustaw 2 linie
		LcdPrint_P( autor );
		}
#endif
	_delay_s( 3,0 );
}



//----------------------------------------------------------------------//
//					Czeka xx sekund i yy setek milisekund				//
// mozliwe czasy od 0.1sek do 9.9sek									// 
//----------------------------------------------------------------------//
void _delay_s( byte sek, byte ms )
{
byte x;


	if (ms>9) ms=9;				// Max 900ms
	if (sek>9) sek=9;			// Max 9sek

	ms = ms + sek * 10;			// _delay_ms(100) powoduje, ze sekunda to 10 a nie 1000 jednostek czasu
	for (x=0; x<ms; x++)
		{
		wdt_reset();
		_delay_ms(100);
		}
}


//----------------------------------------------------------------------//
//					Ustawia IRQ od timera 0								//
//----------------------------------------------------------------------//
/*
void InitTimer0()
{
	TCCR0B = 0x02;					// Preskaler na 8 ~ 1000000/8 = 125000
	TIMSK0 = ( 1<<TOIE0 );			// Zezwolenie na IRQ od przepelnienia timera 0
}
*/


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0								//
//----------------------------------------------------------------------//
/*
INTERRUPT( TIMER0_OVF_vect )
{
static byte dzielnik=1;


	TCNT0 = 256 - 41;									// Przy preskalerze 8 (1MHz / 8) da 3048Hz

	dzielnik--;
}
*/


//----------------------------------------------------------------------//
//					Inicjalizacja WDG									//
//----------------------------------------------------------------------//
void InitWdg()
{
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	#define	WDTO_TIME	WDTO_1S

	wdt_enable( WDTO_TIME );					// Blokuje IRQ !!!
}



//----------------------------------------------------------------------//
//					Obsuga eeprom										//
//----------------------------------------------------------------------//
void ReadCfg()
{
	if ( (sygnatura_eeprom==eeprom_read_dword( &EEsygnatura )) &&	// Jesli sygnatura zgodna
		 (wersja_eeprom==eeprom_read_byte ( &EEwersja )) )
		 {															// Odczytaj konfig
		 eeprom_read_block( Cfg, EEcfg, sizeof(Cfg) );				// odczyt tablicy
		 eeprom_read_block( Kal, EEkal, sizeof(Kal) );				// odczyt tablicy
		 #if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
		  eeprom_read_block( CfgP, EEcfgP, sizeof(Cfg) );				// odczyt tablicy
		  //----- Typ LCD -----// 
		  TypLcd = eeprom_read_byte ( &EEtyplcd ); UstawTypLcd();
		 #endif
		 }															// Sygnatura niezgodna
	else
		{															// Zapisz eeprom i wejdz w konfiguracvje
		WriteCfg();	// Trzeba wykonac zapis, bo gdy wyjdzie sie z kalibracji przez ESC to Cfg nie bedzie zapisane w "KalibracjaMiernika"
		KalibracjaMiernika();
		}
}


//----------------------------------------------------------------------//
void WriteCfg()
{
	wdt_reset();
	eeprom_write_block( Cfg, EEcfg, sizeof(Cfg) );		// Zapis tablicy
	eeprom_write_block( Kal, EEkal, sizeof(Kal) );		// Zapis tablicy
	#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
	 eeprom_write_block( CfgP, EEcfgP, sizeof(Kal) );	// Zapis tablicy
	 eeprom_write_byte ( &EEtyplcd, TypLcd);
	#endif
	eeprom_write_dword( &EEsygnatura, sygnatura_eeprom);
	eeprom_write_byte ( &EEwersja, wersja_eeprom);
}


//----------------------------------------------------------------------//
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)			// Funkcje dostepne dla M168
void UstawTypLcd()
{
  if (TypLcd >= LCD_xEND) TypLcd = 0;
	switch( TypLcd )
		{
		case( LCD2x16 ): LCDLINE = 2; LCDROW = 16; break;
		case( LCD2x20 ): LCDLINE = 2; LCDROW = 20; break;
		case( LCD4x16 ): LCDLINE = 4; LCDROW = 16; break;
		case( LCD4x20 ): LCDLINE = 4; LCDROW = 20; break;
		}
}
#endif


//----------------------------------------------------------------------//

